

/********************************************************************************************************

                                    Script to parse RSS XML data files

                                        Written by Mark Wilton-Jones



Please see http://www.howtocreate.co.uk/jslibs/ for details and a demo of this script

Please see http://www.howtocreate.co.uk/tutorials/jsexamples/importingXML.html for a demo and description

Please see http://www.howtocreate.co.uk/jslibs/termsOfUse.html for terms of use

********************************************************************************************************/

function clicked (section)
    {
        if (widget)
        {
            widget.openURL(section);
        }
    }

function parseRSS(oDocObj) {



	//check if the browser interpreted the XML correctly

	if( oDocObj.documentElement && oDocObj.documentElement.tagName && oDocObj.documentElement.tagName.toUpperCase() == 'HTML' ) {

		setTimeout('alert(\'For no apparent reason, your browser has turned the RSS feed into HTML based garbage.\\nScript aborted.\');',50); return; }

	var chanEl = oDocObj.getElementsByTagName('channel')[0];

	if( !chanEl ) { alert('Format was not recognised as a valid RSS feed'); return; }

	var RSSversion = oDocObj.getElementsByTagName('rssSpoof')[0] ? oDocObj.getElementsByTagName('rssSpoof')[0].getAttribute('version') : '';



	//get the information about the feed

	for( var x = 0, y, feedInfo = []; y = chanEl.childNodes[x]; x++ ) {

		if( y.tagName && y.tagName != 'item' ) {

			if( y.tagName == 'image' ) {

				feedInfo['image'] = [];

				for( var i = 0, j; j = y.childNodes[i]; i++ ) {

					if( j.tagName ) {

						feedInfo['image'][j.tagName] = j.firstChild ? j.firstChild.nodeValue : '';

						if( RSSversion.match(/0?.91/) ) { feedInfo['image'][j.tagName] = feedInfo['image'][j.tagName].replace(/&/g,'&amp;').replace(/"/g,'&quot;').replace(/</g,'&lt;').replace(/>/g,'&gt;'); }

					}

				}

			} else {

				feedInfo[y.tagName] = y.firstChild ? y.firstChild.nodeValue : '';

				if( RSSversion.match(/0?.91/) ) { feedInfo[y.tagName] = feedInfo[y.tagName].replace(/&/g,'&amp;').replace(/"/g,'&quot;').replace(/</g,'&lt;').replace(/>/g,'&gt;'); }

			}

		}

	}



	if( !feedInfo['lastBuildDate'] ) { feedInfo['lastBuildDate'] = feedInfo['pubDate']; }



	//parse each news item

	for( var x = 0, y = oDocObj.getElementsByTagName('item'), newsItems = []; y[x]; x++ ) {

		newsItems[x] = [];

		for( var i = 0, j; j = y[x].childNodes[i]; i++ ) {

			if( j.tagName ) {

				newsItems[x][j.tagName] = j.firstChild ? j.firstChild.nodeValue : '';

				if( RSSversion.match(/0?.91/) ) { newsItems[x][j.tagName] = newsItems[x][j.tagName].replace(/&/g,'&amp;').replace(/"/g,'&quot;').replace(/</g,'&lt;').replace(/>/g,'&gt;'); }

			}

		}

	}



	//now that the entire feed has been converted into JavaScript arrays, it is time to write it out

	//document.title = feedInfo['title'] ? ( 'RSS feed: ' + feedInfo['title'] ) : 'Untitled newsfeed';



	//headers

	var oFeedStr = '<div class="rssarea"><div class="headers">'+

		((feedInfo['image']&&feedInfo['image']['url'])?(

			(feedInfo['image']['link']?('<div class="withImage"><a href="#" onClick="clicked(\''+feedInfo['image']['link']+'\');">'):'')+

			'<img src="'+feedInfo['image']['url']+'" alt="'+(feedInfo['image']['title']?feedInfo['image']['title']:'')+'">'+

			(feedInfo['image']['link']?'<\/a></div>':'')

		):'')+

		//'<h2>'+(feedInfo['link']?('<a href="'+feedInfo['link']+'">'+document.title+'<\/a>'):document.title)+'<\/h2>'+

		//(feedInfo['description']?('<p><b>Description:<\/b> '+feedInfo['description']+'<\/p>'):'')+

		//(feedInfo['lastBuildDate']?('<p><b>Published date:<\/b> '+feedInfo['lastBuildDate']+'<\/p>'):'')+

		'<\/div><div class="newsitems">\n';



	for( var x = 0, y; y = newsItems[x]; x++ ) {

		oFeedStr += '<div class="feeditem"><h3><a href="#" onClick="clicked(\''+newsItems[x]['link']+'\');">'+(newsItems[x]['title']?newsItems[x]['title']:'Untitled')+'<\/a><\/h3>'+

			'<p>'+newsItems[x]['description']+'<\/p><\/div>\n';

	}



	//footer

	oFeedStr += '</div>'+

		//(feedInfo['copyright']?('<div class="footers"><p><b>Copyright:<\/b> '+feedInfo['copyright']+'<\/p><\/div>'):'')+

		'</div>\n';

function RSSParsed(){
	//document.getElementById("fetchingNotice").style.display = 'none';
	newContent = document.getElementById('feedcontaineer');
	newContent.style.display = 'block';
	calculateAndShowThumb(newContent);
}


	//output

	document.getElementById('feedcontaineer').innerHTML = oFeedStr;
	RSSParsed();


}





function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToBack");
    front.style.display="none";
    back.style.display="block";
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}


function hideBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToFront");
    back.style.display="none";
    front.style.display="block";
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}







var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        var starttime = (new Date).getTime() - 13;
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
    T = limit_3(time-animation.starttime, 0, animation.duration);
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}